// Common/StdOutStream.h

#pragma once 

#ifndef __COMMON_STDOUTSTREAM_H
#define __COMMON_STDOUTSTREAM_H

#define	GetCommandLineW g_StdOut.MyGetCommandLineW

#include "../7-zip32.h"
#include "../Dialog.h"

class CStdOutStream
{
public:
	LPWSTR MyGetCommandLineW();
	void SetCommandLine(int argc, LPCSTR const* argv);
	LPCSTR CopyBuf(LPSTR lpCopyBuf, DWORD dwBufSize);
	void ReSet();
	HANDLE m_hThread;
	CProgressDialog* GetProgressDialog() { return m_pDlgProgress; }
	void CloseProgressDialog() { ::PostMessage(m_pDlgProgress->m_hWnd, WM_CLOSE, 0, 1); }
	void SetProgressDialog(CProgressDialog* pDlg) { _ASSERT(!m_pDlgProgress); m_pDlgProgress = pDlg; }
	CStdOutStream ();
	~CStdOutStream ();
	
	CStdOutStream & operator<<(CStdOutStream & (* aFunction)(CStdOutStream  &));
	CStdOutStream & operator<<(const char *string);
	CStdOutStream & operator<<(const wchar_t *string);
	CStdOutStream & operator<<(char c);
	CStdOutStream & operator<<(int number);
	CStdOutStream & operator<<(UINT64 number);
protected:
	DWORD m_dwMaxBuf;
	DWORD m_dwBufSize;
	char* m_lpOutBuf;
	LPWSTR m_lpCommandLine;
	CProgressDialog* m_pDlgProgress;
	void OutProgress(const char* lpszText);
};

CStdOutStream & endl(CStdOutStream & anOut);

extern CStdOutStream g_StdOut;

#endif
