// MyOpenArchive.h: OpenArchive NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_OPENARCHIVE_H__A28A0BBF_060E_4378_9854_0FF8C2A59CFC__INCLUDED_)
#define AFX_OPENARCHIVE_H__A28A0BBF_060E_4378_9854_0FF8C2A59CFC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Common/Wildcard.h"
#include "Common/StringConvert.h"
#include "../../UI/Console/OpenCallback.h"
#include "7-zip32.h"

class COpenArchive
{
public:
	int GetFileCount();
	BOOL GetCompressedSizeEx(ULHA_INT64* lpllSize);
	BOOL GetOriginalSizeEx(ULHA_INT64* lpllSize);
	BOOL GetArcCompressedSizeEx(ULHA_INT64* lpllSize);
	BOOL GetArcOriginalSizeEx(ULHA_INT64* lpllSize);
	BOOL GetArcFileSizeEx(ULHA_INT64* lpllSize);
	BOOL GetArcWriteTimeEx(FILETIME* lpftLastWriteTime);
	BOOL GetArcAccessTimeEx(FILETIME* lpftLastAccessTime);
	BOOL GetArcCreateTimeEx(FILETIME* lpftCreationTime);
//	BOOL GetAccessTimeEx(FILETIME *lpftLastAccessTime);
//	BOOL GetCreateTimeEx(FILETIME *lpftLastCreateTime);
	BOOL GetWriteTimeEx(FILETIME* lpftLastWriteTime);
//	DWORD GetAccessTime();
//	DWORD GetCreateTime();
	DWORD GetWriteTime();
	int GetMethod(LPSTR lpBuffer, const int nSize);
	UINT GetOSType();
	int GetAttribute();
	DWORD GetCRC();
	WORD GetTime();
	WORD GetDate();
	WORD GetRatio();
	DWORD GetCompressedSize();
	DWORD GetOriginalSize();
	int GetFileName(LPSTR lpBuffer, const int nSize);
	int IsSFXFile();
	UINT GetArcOSType();
	WORD GetArcTime();
	WORD GetArcDate();
	WORD GetArcRatio();
	DWORD GetArcCompressedSize();
	DWORD GetArcOriginalSize();
	DWORD GetArcFileSize();
	int GetArcFileName(LPSTR lpBuffer, const int nSize);
	int FindNext(INDIVIDUALINFO *lpSubInfo);
	int FindFirst(LPCSTR lpszWildName, INDIVIDUALINFO *lpSubInfo);
	BOOL Open(LPCSTR lpFileName, DWORD dwMode);
	static void RemoveAll();
	static COpenArchive* FindObject(HARC hArc);
	COpenArchive();
	virtual ~COpenArchive();
	COpenArchive* m_pOAPrev;
	COpenArchive* m_pOANext;

protected:

	CMyComPtr<IInArchive> m_anArchiveHandler;
	NWildcard::CCensor* m_pWildcardCensor;
	UINT32 m_aNumItems;
	UINT32 m_aItemPos;
	UINT64 m_ui64OriginalSize;
	UINT64 m_ui64CompressedSize;
	UINT64 m_ui64ArcCompressedSize;
	UINT64 m_ui64ArcOriginalSize;
	AString m_aFileName;
	AString m_aMode;
//	FILETIME m_ftLastCreateTime;
//	FILETIME m_ftLastAccessTime;
	FILETIME m_ftLastWriteTime;
	DWORD m_dwCRC;
	DWORD m_dwAttribute;
	DWORD m_dwMode;
	WIN32_FIND_DATA m_fdArchive;
	BOOL m_bSearchMode;
	BOOL m_bSolid;
	int m_nArchiveType;
};

#endif // !defined(AFX_OPENARCHIVE_H__A28A0BBF_060E_4378_9854_0FF8C2A59CFC__INCLUDED_)
